var serverurl = "http://ceshi.kuaijilm.com/";

//读文件
function readFile(path, callBack) {
	var fs = api.require('fs');
	var retopen = fs.openSync({
	    path: 'fs://'+path,
	    flags: 'read_write'
	});
	var retread = fs.readSync({
	    fd: retopen.fd,
	    offset: 0,
	    length: 0
	});
	//alert(retread.data);
	callBack(retread);
	// var cacheDir = api.cacheDir;
	// api.readFile({
	// 	path : cacheDir + path
	// }, function(ret, err) {
	// 	callBack(ret, err);
	// });
}

//写文件
function writeFile(json, id, path) {
	var fs = api.require('fs');
var ret = fs.createDirSync({
    path: 'fs://'+path
});
var ret = fs.createFileSync({
    path: 'fs://'+path+'/'+id+ '.txt'
});

var retopen = fs.openSync({
    path: 'fs://'+path+'/'+id+'.txt',
    flags: 'read_write'
});

var retwrite = fs.writeSync({
    fd: retopen.fd,
    data: JSON.stringify(json),
    offset: 0
});
//alert(JSON.stringify(json));


	//缓存目录
	// var cacheDir = api.cacheDir;
	// api.writeFile({
	// 	//保存路径
	// 	path : cacheDir + '/' + path + '/' + id + '.json',
	// 	//保存数据，记得转换格式
	// 	data : JSON.stringify(json)
	// }, function(ret, err) {
	//
	// })
}

//缓存方法
function doCache(folder, id, url,datas) {
	readFile( folder + '/' + id + '.txt', function(ret) {
		if (ret.status) {
			//如果成功，说明有本地存储，读取时转换下数据格式
			//拼装json代码
			//alert('取到缓存')
			var cacheData = ret.data;
			//alert(cacheData);
		//	callback(JSON.parse(cacheData));
			//iCache($('.cache'));
			//再远程取一下数据，防止有更新
			ajaxRequest(url, 'GET', datas, function(ret, err) {
				if (ret) {
				 //alert(cacheData);
				//	alert(JSON.stringify(ret));
					if (cacheData != JSON.stringify(ret)) {
					//	alert(1);

						var fs = api.require('fs');
						var retmove = fs.removeSync({
						    path: 'fs://'+folder+'/'+id+ '.txt'
						});
						// alert(retmove.status);
            // alert(JSON.stringify(ret));
						//有更新处理返回数据
					//	alert(ret);
						///callback(ret);
						//缓存数据
						writeFile(ret, id, folder);
						//iCache($('.cache'));
					}
				} else {
					alert('数据获取失败！');
				}
			})
		} else {
			//如果失败则从服务器读取，利用上面的那个ajaxRequest方法从服务器GET数据
			ajaxRequest(url, 'GET', datas, function(ret, err) {
				if (ret) {
					//处理返回数据
					//alert('没取到缓存')
					//alert(ret);
					//callback(ret);
					//缓存数据
					writeFile(ret, id, folder);
				//	iCache($('.cache'));
				} else {
					alert('数据获取失败！');
				}
			})
		}
	})
}

//缓存图片
function iCache(selector) {
	selector.each(function(data) {! function(data) {
			var url = selector.eq(data).attr("src");
			var img = this;
			var pos = url.lastIndexOf("/");
			var filename = url.substring(pos + 1);
			var path = api.cacheDir + "/pic/" + filename;
			var obj = api.require('fs');
			obj.exist({
				path : path
			}, function(ret, err) {
				//msg(ret);
				if (ret.exist) {
					if (ret.directory) {
						//api.alert({msg:'该路径指向一个文件夹'});
					} else {
						//api.alert({msg:'该路径指向一个文件'});
						//selector.eq(data).src=path;
						selector.eq(data).attr('src', null);
						path = api.cacheDir + "/pic/" + filename;
						selector.eq(data).attr('src', path);
						//console.log(selector.eq(data).attr("src"));
					}
				} else {
					api.download({
						url : url,
						savePath : path,
						report : false,
						cache : true,
						allowResume : true
					}, function(ret, err) {
						//msg(ret);
						if (ret) {
							var value = ('文件大小：' + ret.fileSize + '；下载进度：' + ret.percent + '；下载状态' + ret.state + '存储路径: ' + ret.savePath);
						} else {
							var value = err.msg;
						};
					});
				}//即可自动实现图片缓存
			});
		};
	})
}


function PullRefresh(path,where) {

    api.setRefreshHeaderInfo({
        visible: true,
        loadingImg: 'image/refresh.png',
        bgColor: '#f0f0f0',
        textColor: '#888',
        textDown: '下拉刷新...',
        textUp: '松开刷新...',
        showTime: false
    }, function(ret, err) {

        fnGetList(true,path,where);
    });
};

function PushRefresh(path,where) {
    api.addEventListener({
        name: 'scrolltobottom'
    }, function(ret, err) {
        fnGetList(true,path,where,++page);
    });
};
function init(path,where) {
        fnGetList(false,path,where,page=1);
};


var LIMIT=8;
function fnGetList(isPull,path,where,page)  {
    fnGet(path, where, page, LIMIT, function(ret, err) {
        api.hideProgress();
        api.refreshHeaderLoadDone();

				// alert(JSON.stringify(ret));
      fnShowList(ret, isPull);
    });
};


function fnCacheImage(datas, index) {
    if (datas.length <= index) {
        return;
    }

    api.imageCache({
        url: datas[index].thumbnail.url
    }, function(ret, err) {
        var thumbnail = $api.byId('thumbnail_' + datas[index].id);
        if (thumbnail) {
            thumbnail.src = ret.url;
        }

        fnCacheImage(datas, index + 1);
    });
};

function fnGet(path, where, page, limit, callback) {

    //  api.showProgress({
    //      title: '努力加载中',
    //      modal: false
    //  });
		 //alert(serverurl + path +'?page='+ page + '&limit=' + LIMIT+where);
     api.ajax({
         url:serverurl + path +'?page='+ page + '&limit=' + LIMIT+where,
         method: 'get',
         timeout: 5,
         dataType: 'json',
        //  headers: {
        //      "X-APICloud-AppId": appid,
        //      "X-APICloud-AppKey": appKey
        //  }
     }, function(ret, err) {
//alert(JSON.stringify(ret['bannar']));
         api.refreshHeaderLoadDone();
         api.hideProgress();
         callback(ret, err);
     });
 };

 function fnPost(path, data, isPut, callback) {
		// var headers = {
		// 		"X-APICloud-AppId": appid,
		// 		"X-APICloud-AppKey": appkey
		// };

		// api.showProgress({
		// 		title: '通信中',
		// 		modal: false
		// });
		api.ajax({
				url: serverurl + path,
				method: isPut ? 'put' : 'post',
				timeout: 5,
				dataType: 'json',
				returnAll: false,
			//	headers: headers,
				data: data
		}, function(ret, err) {
				api.refreshHeaderLoadDone();
				 api.hideProgress();
				callback(ret, err);
		});
};


function openNewWindow(type,val,title)
{
	api.sendEvent({
			 name: 'pause_bf',
			 extra: {
					 pause: "start",
			 }
	 });
	iCache($('.cache'));
	var uid=$api.getStorage('uid');
	var footerH = 48;
	//frame的高度为当前window高度减去header和footer的高度
	var frameH = api.winHeight -  footerH;
	if(type=='ask'||type=='usercenter')
	{

				api.openWin({
					name: title,
					url: type+'.html',
				//	delay:800,
					bounces: false,
					animation:{
						type:"movein",                //动画类型（详见动画类型常量）
						subType:"from_right",       //动画子类型（详见动画子类型常量）
						duration:300     //动画过渡时间，默认300毫秒
					},
					bgColor:'#fff',
				 rect: {
						 x: 0,
						 y: 0,
						 w: 'auto',
						 h: frameH
				 },
					pageParam: {
					title: title,
					search:val
				}
				});
	}
	else if(type=='livelist')
	{
		api.openWin({
			name: title,
			url: 'livelist.html',
			//delay:1500,
			bounces: false,
			bgColor:'#fff',
			animation:{
				type:"movein",                //动画类型（详见动画类型常量）
				subType:"from_right",       //动画子类型（详见动画子类型常量）
				duration:300     //动画过渡时间，默认300毫秒
			},
			progress:'page',
			rect: {
					 x: 0,
					 y: 0,
					 w: 'auto',
					 h: frameH
			},
			pageParam: {
			title: title,

		}
		});
	}
	else if(type=='home')
	{
		api.openWin({
			name: title,
			url: 'home.html',
		//	delay:800,
			bounces: false,
			animation:{
				type:"movein",                //动画类型（详见动画类型常量）
				subType:"from_right",       //动画子类型（详见动画子类型常量）
				duration:300     //动画过渡时间，默认300毫秒
			},
			bgColor:'#fff',
			rect: {
					 x: 0,
					 y: 0,
					 w: 'auto',
					 h: 'auto'
			},
			pageParam: {
			title: title,

		}
		});
	}
	else if(type=='question_detail')
	{
		api.openWin({
			name: title,
			url: 'question_detail.html',
			//delay:100,
			bounces: false,
			bgColor:'#fff',
			rect: {
					 x: 0,
					 y: 0,
					 w: 'auto',
					 h: frameH
			},
			pageParam: {
			title: title,
			question_id:val
		}
		});



	}
	else if(type=='tiku_index'||type=='tiku_list')
	{

		api.openWin({
			name: type,
			url: type+'.html',
			//delay:100,
			bounces: false,
			bgColor:'#fff',
			pageParam: {
			title: title,
			sid:val
		}
		});
	}
	else
	{

		api.openWin({
			name: title,
			url: type+'.html',
		//	delay:100,
			bounces: false,
			animation:{
				type:"movein",                //动画类型（详见动画类型常量）
				subType:"from_right",       //动画子类型（详见动画子类型常量）
				duration:300     //动画过渡时间，默认300毫秒
			},
			bgColor:'#fff',
		 rect: {
				 x: 0,
				 y: 0,
				 w: 'auto',
				 h: frameH
		 },
			pageParam: {
			title: title,
			catid:val,
			kcid:""
		}
		});
	}
}


function openWindow(type,sid,kslx,analog_type)
{
	api.openWin({
		name: type,
		url: type+'.html',
		//delay:100,
		bounces: false,
		bgColor:'#fff',
		pageParam: {
		kslx: kslx,
		sid:sid,
		analog_type:analog_type
	}
	});
}

function answer(type,sid,xiaojie_id,kslx) {
	console.info(xiaojie_id)
	api.openWin({
		name: type,
		url: type+'.html',
		//delay:100,
		bounces: false,
		bgColor:'#fff',
		pageParam: {
		kslx: kslx,
		sid:sid,
		xiaojie_id:xiaojie_id
	}
	});
}

function clear_record(event,xiaojieid){
						event.stopPropagation();
											api.confirm({
													 title: '',
													msg: '确定清空做题记录，重新做题吗？',
													buttons: ['确定重做', '取消']
											}, function(ret, err) {
													var index = ret.buttonIndex;
													if(index==1)
													{
														var uid=$api.getStorage('uid');
													//	uid=669&xiaojieid=147&clear=clear
													var db = api.require('db');
													var dbName = "kuaijilm";
													var exam_history_del="DELETE FROM exam_historys WHERE  uid ="+uid+" and xiaojie_id="+xiaojieid;
													//alert(order_del);
													var del_ret=db.executeSqlSync({
																 name: dbName,
																 sql :  exam_history_del
													});

														var data={
																values:{
																	"xiaojieid":xiaojieid,"uid":uid,"clear":"clear"
																}
														};
														//alert(JSON.stringify(data));
														var path="api/exam/store";
														var isPut=false;
														fnPost(path,data,isPut,function(ret,err){
																					if(ret.status==1){
																						api.toast({
																								msg: '清空做题记录完成,前往重新做题',
																								duration: 1000,
																								location: 'bottom'
																						});

																								answer('tiku_exam',api.pageParam.sid,xiaojieid,api.pageParam.kslx)
																					}
														})
													}
											});
										}

function SetString(str,len)
{
		var strlen = 0;
		var s = "";
		for(var i = 0;i < str.length;i++)
		{
		if(str.charCodeAt(i) > 128){
		strlen += 2;
		}else{
		strlen++;
		}
		s += str.charAt(i);
		if(strlen >= len){
		return s ;
		}
		}
		return s;
}


function htmldecode(str) {
	str = str.replace(/&amp;/g, '&');
	str = str.replace(/&nbsp;/g, ' ');
	str = str.replace(/&quot;/g, '"');
	str = str.replace(/&#39;/g, "'");
	str = str.replace(/&lt;/gi, '<');
	str = str.replace(/&gt;/gi, '>');
	//	str = str.replace(/<p>/g, '');
	//	str = str.replace(/<\/p>/g, '');
	//	str = str.replace(/<img/g, '<img style="width:100%;"');
	return str;
}


function isEmpty(obj) {
    // 用变量保存可以加速对对象原型的hasOwnProperty的访问。
    var hasOwnProperty = Object.prototype.hasOwnProperty;
    // 本身为空直接返回true
     if (obj == null) return true;    // 然后可以根据长度判断，在低版本的ie浏览器中无法这样判断。
     if (obj.length > 0)    return false;
     if (obj.length === 0)  return true;    //最后通过属性长度判断。
     for (var key in obj) {
         if (hasOwnProperty.call(obj, key))
             return false;
     }
     return true;
}

//aa数组是否包含bb数组
function isContained(aa,bb){
    if(!(aa instanceof Array)||!(bb instanceof Array)||((aa.length < bb.length))){
        return false;
    }
    var aaStr = aa.toString();
    for (var i = 0 ;i < bb.length;i++) {
        if(aaStr.indexOf(bb[i]) < 0) return false;
    }
    return true;
}


//字符串转换为时间戳
function getDateTimeStamp (dateStr) {
    return Date.parse(dateStr.replace(/-/gi,"/"));
}

function getDateDiff(dateStr) {
    var publishTime = getDateTimeStamp(dateStr)/1000,
        d_seconds,
        d_minutes,
        d_hours,
        d_days,
        d_months,
        d_years,
        timeNow = parseInt(new Date().getTime()/1000),
        d,

        date = new Date(publishTime*1000),
        Y = date.getFullYear(),
        M = date.getMonth() + 1,
        D = date.getDate(),
        H = date.getHours(),
        m = date.getMinutes(),
        s = date.getSeconds();

			//	alert(publishTime);alert(timeNow);
    //小于10的在前面补0
    if (M < 10) {
        M = '0' + M;
    }
    if (D < 10) {
        D = '0' + D;
    }
    if (H < 10) {
        H = '0' + H;
    }
    if (m < 10) {
        m = '0' + m;
    }
    if (s < 10) {
        s = '0' + s;
    }

    d = timeNow - publishTime;
		if(d<60)
		{
			if(d<10)
			{
				return '刚刚发表';
			}else {
				return  d + '秒前';
			}
		}else {
			d_years=parseInt(d/31536000);
	    d_months=parseInt(d/2592000);
	    d_days = parseInt(d/86400);
	    d_hours = parseInt(d/3600);
	    d_minutes = parseInt(d/60);
	    d_seconds = parseInt(d);
		}

    if(d_years > 0 ) {
        return d_years + '年前';
    }else if(d_months > 0 && d_years <=0) {
        return d_months + '月前';
    }else if(d_days > 0 && d_days < 31){
        return d_days + '天前';
    }else if(d_days <= 0 && d_hours > 0){
        return d_hours + '小时前';
    }else if(d_hours <= 0 && d_minutes > 0){
        return d_minutes + '分钟前';
    }else if (d_seconds < 60) {
         if (d_seconds <= 0) {
      			return '刚刚发表';
         }else {
            return d_seconds + '秒前';
        }
    }else if (d_days >= 3 && d_days < 30){
        return M + '-' + D + '&nbsp;' + H + ':' + m;
    }else if (d_days >= 30) {
        return Y + '-' + M + '-' + D + '&nbsp;' + H + ':' + m;
    }
}

var time_to_sec = function (time) {
		 var s = '';

		 var hour = time.split(':')[0];
		 var min = time.split(':')[1];
		 var sec = time.split(':')[2];

		 s = Number(hour*3600) + Number(min*60) + Number(sec);

		 return s;
 };

 function formatTime(second) {
		 return [parseInt(second / 60 ), parseInt(second % 60)].join(":")
				 .replace(/\b(\d)\b/g, "0$1");
 }

//时间戳转字符串
function timestampToTime(timestamp) {
        var date = new Date(timestamp * 1000);//时间戳为10位需*1000，时间戳为13位的话不需乘1000
        Y = date.getFullYear() + '-';
        M = (date.getMonth()+1 < 10 ? '0'+(date.getMonth()+1) : date.getMonth()+1) + '-';
        D = date.getDate()< 10 ? '0'+date.getDate():date.getDate() + '   ';
        h = date.getHours()< 10 ? '0'+date.getHours():date.getHours() + ':';
        m = date.getMinutes()< 10 ? '0'+date.getMinutes():date.getMinutes() + ':';
        s = date.getSeconds()< 10 ? '0'+date.getSeconds():date.getSeconds();
        return Y+M+D+'  '+h+m+s;
    }
    // timestampToTime(1403058804);
    // console.log(timestampToTime(1403058804));//2014-06-18 10:33:24
		var subSet = function(arr1, arr2) {
				 var len = arr1.length;
				 var arr = [];

				 while (len--) {
						 if (!inArray(arr1[len],arr2))
						 {
							 //console.info(arr1[len])
							arr.push(arr1[len]);
						 }
				 }

				 return arr;
		 };

		 function inArray(search,array){
					for(var i in array){
							if(array[i]==search){
									return true;
							}
					}
					return false;
			}

			function str_to_arr(str,dot) {
				if(isEmpty(str))
				{
					return [];
				}
				return str.split(dot);
			}


			function remove(arr,val) {
				 for(var i = 0; i < arr.length; i++) {
					 if(arr[i] == val) {
						 arr.splice(i, 1);
					 }
				 }
				 return arr;
			 }

			 function type_name(catid)
					 {
							 return {
									 '1' :'单选题',
									 '2' : '多选题',
									 '3' : '判断题',
									 '5' : (catid == 86) ? '不定项选择' : '计算分析题',
									 '6' : '简答题',
									 '7' : '综合题',
									 '8' : '计算回答题',
									 '9' : '案例分析题',
									 '10' : '综合分析题'
								 };
					 }


					 var cn_int=['一','二','三','四','五','六','七','八','九','十','十一','十二','十三','十四','十五','十六','十七','十八','十九','二十'];
					 function get_array_index(search,array) {
							 for(var i in array){
									 if(array[i]==search){
											 return i;
									 }
							 }
							 return -1;
					 }
