$(function () {

    //题库首页，题库分类展示隐藏
    $('.example-card .top').click(function () {

        var content = $(this).siblings('.content'),
            img = $(this).find('.more img');

        if ( content.is(':hidden') )
        {
            content.slideDown();
            img.attr('src','/static/example/mobile/version1/images/reduce.png')
        }
        else
        {
            content.slideUp();
            img.attr('src','/static/example/mobile/version1/images/plus.png')
        }
    });

    //切换科目
    $('#change_subject').click(function () {

        layer.open({
            type: 1,
            content: $('#change_subject_template').html(),
            anim: 'up',
            style: 'position:fixed; bottom:0; left:0; width: 100%; height: 6.5rem; padding:10px 0; border:none;'
        });

    });


    //题库章节列表页
    $('.chapter-list .chapter .chapter-title').click(function () {

        var section = $(this).siblings('.section'),
            img = $(this).find('img');

        if ( section.is(':hidden') )
        {
            section.slideDown();
            img.attr('src','/static/example/mobile/version1/images/reduce1.png')
        }
        else
        {
            section.slideUp();
            img.attr('src','/static/example/mobile/version1/images/plus1.png')
        }
    });

    //切换类型
    $('#change_kslx').click(function () {

        layer.open({
            type: 1,
            content: $('#change_kslx_template').html(),
            anim: 'up',
            style: 'position:fixed; bottom:0; left:0; width: 100%; height: 4.5rem; padding:10px 0; border:none;'
        });

    });

    //错题/收藏 右侧浮动切换
    $('.change-referer .change').click(function () {

        // $('.referer .chapter-referer').stop().animate({right:'6px'});

        var div = $(".change-referer .referer div"),
            i = div.length,
            n = i-1,
            r = 90;

        $(this).toggleClass('active');
        $(this).siblings('.shade').fadeToggle();

        if($(this).hasClass('active'))
        {
            $(this).empty().html('隐藏');

            for(var a = 0; a < i; a++)
            {
                div.eq(a).css({
                    'transition-delay': "" + (50 * a) + "ms",
                    '-webkit-transition-delay': "" + (50 * a) + "ms",
                    '-o-transition-delay': "" + (50 * a) + "ms",
                    'transform': "translate(" + (-r * Math.cos(90 / n * a * (Math.PI / 180))) + "px," + (-r * Math.sin(90 / n * a * (Math.PI / 180))) + "px",
                    '-webkit-transform': "translate(" + (-r * Math.cos(90 / n * a * (Math.PI / 180))) + "px," + (-r * Math.sin(90 / n * a * (Math.PI / 180))) + "px",
                    '-o-transform': "translate(" + (-r * Math.cos(90 / n * a * (Math.PI / 180))) + "px," + (-r * Math.sin(90 / n * a * (Math.PI / 180))) + "px",
                    '-ms-transform': "translate(" + (-r * Math.cos(90 / n * a * (Math.PI / 180))) + "px," + (-r * Math.sin(90 / n * a * (Math.PI / 180))) + "px"
                });
            }
        }
        else
        {
            $(this).empty().html('展示');
            div.removeAttr('style');
        }

    });
    //点击遮罩层隐藏
    $('.change-referer .shade').click(function () {
        $(this).fadeOut().find('.referer').fadeOut();
        $('.change-referer .change').toggleClass('active').empty().html('展示');
        $('.change-referer .referer div').removeAttr('style');
    });


    //查看答案
    $('body').on('touchstart','#show_answer',function () {

        var answer = $('#example_answer'),
            title =$(this).find('.title');

        if ( answer.is(':hidden') )
        {
            answer.slideDown();
            title.empty().html('隐藏答案');
        }
        else
        {
            answer.slideUp();
            title.empty().html('答案解析');
        }

    });

    //答题卡
    $("body").on('touchstart','#answer_card',function () {

        $('.answer-card-shade').fadeIn();
        $('.answer-card-template').slideDown();

    });
    $("body").on('touchstart','.answer-card-shade',function () {

        $('.answer-card-shade').fadeOut();
        $('.answer-card-template').slideUp();

    });
    $("body").on('touchstart','.close',function () {

        $('.answer-card-shade').fadeOut();
        $('.answer-card-template').slideUp();

    });

    //答题工具
    $('body').on('touchstart','#answer_tool',function (e) {

        e.stopPropagation();
        $('.answer-tool').fadeToggle();

    });
    $('body').on('click','#answer_tool',function (e) {

        e.stopPropagation();

    });
    $('body').on('touchstart','#answer_tool',function (e) {

        e.stopPropagation();

    });
    $(document).click(function () {

        $('.answer-tool').fadeOut();
    });
    //计算器
    $('body').on('touchstart','.answer-tool .calculator',function (e) {

        $('#calculator').fadeIn();
    });
    $('body').on('touchstart','#calculator .close',function (e) {

        $('#calculator').fadeOut();
    });


});

var alertMsg = function (msg,time) {
    time = time || 2;
    layer.open({
        content: msg
        ,skin: 'msg'
        ,time: time
    });

};

//登录
//href 登陆后回跳地址，为空则到用户中心
function login(href){

    href = href || '';

    layer.open({
        content: '<p style="color:#ff9600;font-size: 0.3rem;letter-spacing: 0.5px;">您好，请先登录哦^_^！</p>',
        btn: ['马上登录', '取消'],
        skin: 'footer',
        yes: function (index) {

            location.href = href;

            layer.close(index);
        }
    });
}

function loading() {
    layer.open({
        type: 2
        ,content: '题目加载中...'
    });
}

function tishi(content) {
    content = '<p style="color:#ff9600;font-size: 0.3rem;letter-spacing: 0.5px;">' + content + '！</p>';
    layer.open({
        content: content
        , btn: '确认'
    });
}

function tankuan(content) {
    layer.open({
        content: content
        , skin: 'msg'
        , time: 2 //2秒后自动关闭
    });
}

function ask(content) {
    layer.open({
        content: content
        , btn: ['确定', '不要']
        , yes: function (index) {
            location.reload();
            layer.close(index);
        }
    });
}
